
# Rewire: A Streamlined Type-Based Dependency Injection Framework for Focused Development

Rewire is a user-friendly framework dedicated to type-based dependency injection, allowing developers to focus on writing code rather than dealing with boilerplate.

## Installation

Install Rewire using pip: `pip install rewire`

## Key Features and Benefits

### Dependency Injection

Employ Rewire's advanced type-based dependency injection system to automatically manage the instantiation, configuration, and resolution of components in your application. This lets you concentrate on
developing functionality without being bogged down by dependency management.

### Configuration Injection (YAML & Python Functions)

Easily load configurations from a YAML file using Rewire's versatile configuration injection mechanism, which supports Python function extensions. Set up complex applications with ease and consistency
while maintaining flexibility.

### Automatic File Import

Automatically import required files based on defined configurations within your Rewire-powered application. Keep your project organized by trusting Rewire to handle file imports, promoting code
reusability and minimizing potential errors.

### Lifecycle Manager

Easily manage the lifecycles of components with Rewire's robust start/stop manager. Control the initialization and disposal of resources efficiently, ensuring optimal resource usage.

### Extensibility & Hackability

Rewire is designed to be both extensible and hackable, enabling developers to tailor the framework to their specific needs. Customize components, add new features, or integrate Rewire with other
libraries as desired, making it a powerful choice for any project.


## Examples

* [Simple FastAPI app](https://github.com/rewirepy/example-fastapi)
